



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>利用C#轻松创建不规则窗体</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">利用C#轻松创建不规则窗体</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 05:27:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>1.准备一个不规则的位图</strong></p>
<p>可以使用任意一种你喜欢的作图工具，制作一个有形状的位图，背景使用一种其他的颜色。这个颜色在编程中用得着，所以最好使用一种容易记忆的颜色。如黄色，文件名为bk.bmp</p>
<p><strong>2.创建窗体并设置属性</strong></p>
<p>1）将 FormBorderStyle 属性设置为 None。</p>
<p>2）将窗体的 BackgroundImage 属性设置为先前创建的位图文件。不必将文件添加到项目系统中，这将在指定该文件作为背景图像时自动完成。</p>
<p>3）将 TransparencyKey 属性设置为位图文件的背景色，如：黄色。（此属性告诉应用程序窗体中的哪些部分需要设置为透明。）</p>
<p>这时你就可以按F5测试你的程序，可以看到如图所示的窗体。现在窗体还不能拖动，只能通过结束程序，或者alt+F4关闭。下面我们编写相应的代码来实现标题栏的相应功能。</p>
<p><strong>3.编写相关代码</strong>（要实现窗口的关闭，移动等操作）<br />1）实现窗口关闭</p>
<p>从工具栏中拖进一个按钮，设置其按钮文字为&ldquo;&times;&rdquo;，设置其大小为合适大小。双击该按钮进入其触发事件函数。写入如下代码：&nbsp;this.Close();&nbsp;//关闭本窗体</p>
<p>2）设置窗体的移动操作，我们要用到两个全局的变量</p>
<div>
<pre class="prettyprint linenums"> private Point mouseOffset; //记录鼠标指针的坐标<br />
 private bool isMouseDown = false; //记录鼠标按键是否按下<br />
 private void Form1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e){<br />
     int xOffset;<br />
     int yOffset;<br />
     if (e.Button == MouseButtons.Left){<br />
         xOffset = -e.X - SystemInformation.FrameBorderSize.Width;<br />
         yOffset = -e.Y - SystemInformation.CaptionHeight -<br />
                   SystemInformation.FrameBorderSize.Height;<br />
         mouseOffset = new Point(xOffset, yOffset);<br />
         isMouseDown = true;<br />
     }<br />
 }<br />
 private void Form1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e){<br />
     if (isMouseDown){<br />
         Point mousePos = Control.MousePosition;<br />
         mousePos.Offset(mouseOffset.X, mouseOffset.Y);<br />
         Location = mousePos;<br />
     }<br />
 }<br />
 private void Form1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e){<br />
     // 修改鼠标状态isMouseDown的值，确保只有鼠标左键按下并移动时，才移动窗体<br />
     if (e.Button == MouseButtons.Left){<br />
         isMouseDown = false;<br />
     }<br />
 }</pre>
</div>
<p>3）加入相应的其他的控件</p>
<p>其他的就是看你自己的需要，来添加控件，实现自己想要实现的功能。本例中添加了一文本框，设置其背景为黄色，所以显示时也成了透明的。</p>
<p>现在，我们就可以生成程序，看一下最后的效果了。</p>
<p>查看原文：http://blog.sina.com.cn/s/blog_3d7bed650100b90a.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39r0pmr9.html">金山软件wps2012-2013通杀0day</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8er5vjq.html">MySQL修改默认字符集</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rkx2eq.html">分享50款 Android 移动应用程序图标【下篇】</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96rxmn9.html">Nmcli 网络管理命令行工具基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96e6lvq.html">&lbrack;Node&period;js&rsqb; 使用File API 异步上传文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw31zz9.html">ubuntu更新删除旧内核的shell脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2rgkl9.html">Java for LeetCode 155 Min Stack</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oxzjj9.html">PHP MySQL Select 之Select</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj15kj8.html">HTML5 实现拖拽</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1klo469.html">解密Lazy&amp;lt&semi;T&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/96p42348.html">ProjectA&colon; 多元非线性回归</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdwkdz9.html">图像旋转、伸缩的自写matlab实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyg7pv9.html">mysql数据库的基本操作命令总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyydm3mq.html">CefSharp 与 js 相互调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1py2xq.html">Java程序员面试中的多线程问题1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx26x1d8.html">关于jquery的serialize方法转换空格为&plus;号的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx244r08.html">django project 的快速构建</a>
		</li>
						<li><a href="https://www.batexi.com/a/953y3vm8.html">hdoj1203 I NEED A OFFER&excl;（DP，01背包）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmge009.html">eschop购物实现立即购买和加入购物车</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k7nm3q.html">Socket长连接和短连接的区别</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93xe4yg9.html">从汇编看c&plus;&plus;的new和delete</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd1gny8.html">illegal to have multiple occurrences of contentType with different values &lpar;old&colon; text&sol;html&semi; charset&equals;UTF-8&comma; new&colon; text&sol;html&semi; charset&equals;utf-8&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm2o4z9.html">Linux下源码编译安装rpy2</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x42768.html">django之uWSGI配置 &plus;Nginx</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1z01x59.html">windows下安装配置Xampp</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yrl05q.html">Turn the corner--hdu2438&lpar;3分法&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdenno09.html">div&plus;css树形菜单</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yxy3jq.html">关于App的一些迷思以及一些动画效果开源库的推荐</a>
			</li>
						<li><a href="https://www.batexi.com/a/93x5x6g9.html">leetcode&lowbar;question&lowbar;104 Maximum Depth of Binary Tree</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd6d138.html">网易云课堂&lowbar;C&plus;&plus;开发入门到精通&lowbar;章节4&colon;运算符重载</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
